summaryrefslogtreecommitdiff
path: root/tests/misc/md5sum-newline
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2008-05-14 09:37:02 +0200
committerJim Meyering <meyering@redhat.com>2008-05-17 08:27:58 +0200
commit1081bbc74e48010700783a9bb82a4657d1d02bd2 (patch)
tree41694f8ec4c2400349a367bb3680db8f09951438 /tests/misc/md5sum-newline
parentea54b6f47c92525267861e15314c61db83a86352 (diff)
downloadcoreutils-1081bbc74e48010700783a9bb82a4657d1d02bd2.tar.xz
tests: remove ugly /bin/sh wrapper around each perl-based test script
* tests/check.mk (TESTS_ENVIRONMENT): Save and restore TMPDIR around envvar-check, so that the few scripts that require $TMPDIR don't fail. This is also good to let a user's default TMPDIR setting be used e.g., in the search for an 'other-partition'. FIXME: this is pretty ugly. maybe undo it and find a better way. (TESTS_ENVIRONMENT): Invoke perl scripts with $(PERL), and use -T if the script requires that. Otherwise, use $(SHELL). * tests/misc/md5sum-newline: Create a file whose name contains a newline in Perl (resort to using "system", since open refuses). Fix old brokenness exposed by this change: * tests/du/files0-from: Correct test not to rely on stdin being attached to a non-tty. * tests/misc/sort (3g, 3h, 3i): Likewise: add explicit empty input file. Avoid warnings about using qw()-around-commas. * tests/rm/fail-eperm: Now that this test is run from a temporary subdirectory, adjust the full name of the "rm" program we're going to run. Change #!/bin/sh to #!/usr/bin/perl, and factor out the few lines of boilerplate code to invoke perl. Do not "require 5.00x"; a configure-time Perl test handles that * tests/dd/skip-seek: * tests/misc/base64: * tests/misc/basename: * tests/misc/cut: * tests/misc/date: * tests/misc/dircolors: * tests/misc/dirname: * tests/misc/expand: * tests/misc/expr: * tests/misc/factor: * tests/misc/fmt: * tests/misc/fold: * tests/misc/head: * tests/misc/head-elide-tail: * tests/misc/join: * tests/misc/ls-misc: * tests/misc/md5sum: * tests/misc/md5sum-newline: * tests/misc/mktemp: * tests/misc/od: * tests/misc/paste: * tests/misc/pr: * tests/misc/printf-cov: * tests/misc/seq: * tests/misc/sha1sum: * tests/misc/sha1sum-vec: * tests/misc/sha224sum: * tests/misc/sha256sum: * tests/misc/sha384sum: * tests/misc/sha512sum: * tests/misc/sort-merge: * tests/misc/stat-printf: * tests/misc/sum: * tests/misc/tac: * tests/misc/tail: * tests/misc/test: * tests/misc/test-diag: * tests/misc/tr: * tests/misc/tsort: * tests/misc/tty-eof: * tests/misc/unexpand: * tests/misc/uniq: * tests/misc/wc: * tests/misc/wc-files0-from: * tests/misc/xstrtol: * tests/mv/i-1: * tests/pr/pr-tests: * tests/rm/empty-name: * tests/rm/fail-eperm: * tests/rm/unreadable:
Diffstat (limited to 'tests/misc/md5sum-newline')
-rwxr-xr-xtests/misc/md5sum-newline28
1 files changed, 6 insertions, 22 deletions
diff --git a/tests/misc/md5sum-newline b/tests/misc/md5sum-newline
index ed6b85ceb..ef1bbcceb 100755
--- a/tests/misc/md5sum-newline
+++ b/tests/misc/md5sum-newline
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/usr/bin/perl
# Newline tests for "md5sum".
# Copyright (C) 1999, 2000, 2003, 2005, 2007-2008 Free Software Foundation, Inc.
@@ -16,26 +16,6 @@
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
-: ${srcdir=.}
-. $top_srcdir/tests/require-perl
-
-# See if we can create a filename that contains a newline.
-# Be careful to do it in a subshell so that we can redirect the
-# error output if it fails.
-(> 'a
-b') 2> /dev/null \
- && filename_may_contain_newline=yes \
- || filename_may_contain_newline=no
-rm -f 'a
-b'
-
-if test $filename_may_contain_newline = no; then
- skip_test_ "failed to create newline-containing file name"
-fi
-
-me=`echo $0|sed 's,.*/,,'`
-exec $PERL -w -I$top_srcdir/tests -MCoreutils -M"CuTmpdir qw($me)" -- - <<\EOF
-require 5.003;
use strict;
(my $program_name = $0) =~ s|.*/||;
@@ -43,6 +23,11 @@ use strict;
# Turn off localization of executable's output.
@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3;
+# See if we can create a file name that contains a newline.
+# Use system, since Perl doesn't let you do this with "open".
+system ('touch', "a\nb") == 0
+ or (warn "$0: failed to create newline-containing file name\n"), exit 77;
+
my $degenerate = "d41d8cd98f00b204e9800998ecf8427e";
my $t = '--text';
@@ -57,4 +42,3 @@ my $verbose = $ENV{VERBOSE};
my $prog = 'md5sum';
my $fail = run_tests ($program_name, $prog, \@Tests, $save_temps, $verbose);
exit $fail;
-EOF